
Redmine - Feature #2653

New permission for issues: view_own_issue

2009-02-03 10:06 - Stanislav German-Evtushenko

Status: Closed Start date: 2009-02-03

Priority: Normal Due date:  

Assignee:  % Done: 0%

Category: Issues permissions Estimated time: 0.00 hour

Target version:    

Resolution: Duplicate   

Description

It will be useful to use redmine for incoming tasks from external clients. Clients will have access to own issues, but haven't access to

other. It is seems as "Private issues" #337, but it is not.

Related issues:

Related to Redmine - Feature #2331: Restricting issue listing for some roles ... Closed 2008-12-12

Related to Redmine - Defect #4756: "Add Issues" permission problem Closed 2010-02-08

Related to Redmine - Feature #6015: Private Users New 2010-08-02

Has duplicate Redmine - Feature #7547: Need new role: "view only my issues" Closed 2011-02-04

Is duplicate of Redmine - Feature #7412: Add an issue visibility level to eac... Closed 2011-01-22

History

#1 - 2009-02-27 16:08 - Jean-Philippe Lang

- Category changed from Permissions and roles to Issues permissions

#2 - 2009-07-04 21:08 - Maik Derstappen

+1

#3 - 2009-07-05 11:03 - Jan from Planio www.plan.io

+1

#4 - 2009-07-24 12:15 - Holger Winkelmann

+1

#5 - 2009-07-25 02:19 - Enderson Maia

+1

#6 - 2009-07-28 23:17 - Thomas Pihl

See #3187

#7 - 2009-07-28 23:24 - Dmitry Shkolnikov

+1

#8 - 2009-09-15 11:07 - J Cayetano Delgado

+1

#9 - 2009-11-17 11:29 - Tiago  Queirós

+1

#10 - 2009-11-17 20:52 - Stanislav German-Evtushenko

I think it would be great if it will be implemented in 0.9 in addition to Private issues #337.

#11 - 2009-11-27 04:22 - Ho Nguyen

+1
#12 - 2009-11-27 07:48 - Lucas Panjer

+1

#13 - 2009-12-02 17:55 - Stanislav German-Evtushenko

It seems as resolved here in issue #3187!

#14 - 2009-12-02 19:00 - Stanislav German-Evtushenko

Stanislav German-Evtushenko wrote:

It seems as resolved here in issue #3187!

 No :(

Isn't implemented yet

#15 - 2009-12-07 13:34 - Christophe Le Guern

+1

#16 - 2009-12-23 21:19 - Stanislav German-Evtushenko

- Assignee set to Jean-Philippe Lang

Hello Jean-Philippe,

Could it be implemented in 0.9 version?

#17 - 2010-02-17 15:49 - Alexander Stehlik

+1

#18 - 2010-04-18 18:21 - Thomas Pihl

+1 (would be really great)

#19 - 2010-04-24 07:13 - Oleg Volkov

What is different from #337 ?

#337 is already working

For external users (Not member):

- set "View issue"

- unset "Add issue"

- set "Add private issue"

- unset "View private issue"

For internal users (Developer, Manager):

- set "View issue"

- set or unset "Add issue"

- set or unset "Add private issue"

- set "View private issue"

#20 - 2010-04-25 11:35 - Thomas Pihl

The difference is that external users will see each others issues.

This is in alot of situations not desirable.

Currently we solve this with different projects per customer/user but would really like to make sure that each external user only see their own issues.

#21 - 2010-04-25 11:44 - Oleg Volkov

External users will NOT see each others PRIVATE issues.

#22 - 2010-04-25 11:49 - Thomas Pihl

True, but we don't want them to be able to enter anything that can be seen by other users, no matter how they mark it.

All their issues should be isolated from each others and support-center can work with them all.

#23 - 2010-04-25 11:51 - Thomas Pihl

I will read up on your #337 and do some tests.
You might be right or i need to formulate my ideas better.

BR,

Thomas

#24 - 2010-04-25 12:00 - Oleg Volkov

External users (not member):

- not view other issues,

- view own issues

Developer users view all issues.

See #337 description and http://www.redmine.org/issues/2653#note-19

#25 - 2010-04-25 12:00 - Stanislav German-Evtushenko

Private issues looks like a little bit complex workaround for "view_own_issue".

#26 - 2010-04-25 12:12 - Oleg Volkov

#337 is able to work, please test it

#27 - 2010-04-25 13:43 - Stanislav German-Evtushenko

Oleg Volkov wrote:

#337 is able to work, please test it

 I believe that it should work. Nevertheless it's really more than necessary. "View own issue" and "Create an issue" permissions would be enough I

think.

#28 - 2010-04-25 13:55 - Oleg Volkov

Why?

#29 - 2010-04-25 14:12 - Stanislav German-Evtushenko

I'm not sure how can one use "Private tasks". You can use private project instead.

For example: I have two projects: IT Tasks (primary) and Helpdesk (child project).

Primary task is private - just only for IT team. Helpdesk - public project. And I think it would be nice if helpdesk users can see only their owned task

and nothing else in the "helpdesk" project.

#30 - 2010-04-25 14:32 - Oleg Volkov

Set "Public" for Helpdesk project, unset "Public" for IT Tasks projects.

Unset "Add issue" for "Not member".

Set "Add private issue" for "Not member".

Set "View private issue" for "Developer" (for view all private issue).

#31 - 2010-04-25 14:42 - Stanislav German-Evtushenko

Oleg Volkov wrote:

Set "Public" for Helpdesk project, unset "Public" for IT Tasks projects.

Unset "Add issue" for "Not member".

Set "Add private issue" for "Not member".

Set "View private issue" for "Developer" (for view all private issue).

 I got it, but I'm still not sure what the reason to do two types of issues (private and not private) when just only one enough?

#32 - 2010-04-25 14:43 - Stanislav German-Evtushenko

enough => is enough

#33 - 2010-04-25 15:31 - Oleg Volkov

Unset "Add issue" to all

Set "Add private issue" to all

#34 - 2010-04-25 17:14 - Thomas Pihl

It might be only terminology.
And i can see a point of being able to have both private and public issues in same project. Some helpdesk issues you may want to show to everyone

but only after you first saw them (as private).

Also useful if you have a project with like a stearing group as guests. Some issues may be better hidden.

BR,

Thomas

#35 - 2010-05-02 17:09 - Oleg Volkov

- File redmine_own_v.1.patch added

This patch adds the ability to view own issues in the case if you have "Add issue" and not found "View issue".

Own issues are:

- created

- assigned

- watchers

Please test my patch and write reviews.

#36 - 2010-05-03 20:59 - Sergey Belov

This patch works fantastic. It's better that "private issue" patch because it works for old issues, and don't need to migrate db

Jean-Philippe, please take a look on this patch

#37 - 2010-05-03 22:20 - Stanislav German-Evtushenko

Thanks a lot, Oleg!

I'll try it on the 0.8-stable.

#38 - 2010-05-04 13:46 - Stanislav German-Evtushenko

I didn't manage to apply this patch for redmine 0.8 because there ara too much differences between 0.8 and 0.9 at the moment.

$ patch -p1 --dry-run < redmine_own_v.1.patch 

patching file app/controllers/issues_controller.rb

Hunk #1 succeeded at 99 (offset -5 lines).

patching file app/models/issue.rb

Hunk #1 FAILED at 62.

1 out of 1 hunk FAILED -- saving rejects to file app/models/issue.rb.rej

patching file app/models/query.rb

Hunk #1 succeeded at 259 with fuzz 2 (offset -87 lines).

Hunk #2 succeeded at 281 (offset -87 lines).

Hunk #3 succeeded at 328 with fuzz 1 (offset -90 lines).

patching file app/models/user.rb

Hunk #1 FAILED at 289.

Hunk #2 FAILED at 297.

2 out of 2 hunks FAILED -- saving rejects to file app/models/user.rb.rej

patching file lib/redmine.rb

Hunk #1 succeeded at 18 with fuzz 2 (offset -7 lines).

Hunk #2 FAILED at 31.

Hunk #3 succeeded at 68 (offset -11 lines).

Hunk #4 succeeded at 89 (offset -11 lines).

1 out of 4 hunks FAILED -- saving rejects to file lib/redmine.rb.rej

patching file test/fixtures/issues.yml

Hunk #1 FAILED at 10.

Hunk #2 FAILED at 86.

Hunk #3 FAILED at 202.

3 out of 3 hunks FAILED -- saving rejects to file test/fixtures/issues.yml.rej

can't find file to patch at input line 201

Perhaps you used the wrong -p or --strip option?

The text leading up to this was:

--------------------------

|diff -ur redmine-0.9.4/test/fixtures/member_roles.yml redmine/test/fixtures/member_roles.yml

|--- redmine-0.9.4/test/fixtures/member_roles.yml    2010-05-01 16:43:49.000000000 +0400

|+++ redmine/test/fixtures/member_roles.yml    2010-05-02 11:23:54.235688297 +0400

--------------------------

File to patch:

#39 - 2010-05-04 21:55 - Oleg Volkov

Patch for 0.9.4 and hi.
#40 - 2010-05-05 13:00 - Raghu Sunderam

Hello Oleg

Thank you very much for implementing this long requested feature via a simple patch.

I have applied the patch in my installation of redmine v0.94.

The version is a stable one and not a snapshot.

I used the following command to apply the patch # patch -p1 < redmine_own_v.1.patch

I got the following as output

patching file app/controllers/issues_controller.rb

patching file app/models/issue.rb

patching file app/models/query.rb

patching file app/models/user.rb

patching file lib/redmine.rb

patching file test/fixtures/issues.yml

patching file test/fixtures/member_roles.yml

patching file test/fixtures/members.yml

patching file test/fixtures/roles.yml

patching file test/fixtures/users.yml

patching file test/fixtures/watchers.yml

patching file test/functional/issues_controller_test.rb

patching file test/unit/issue_test.rb

patching file test/unit/mailer_test.rb 

 So i assumed the patch has been applied successfully.

I went to Roles and Permission and could not find any check box called "View Private Issues" or "Add Private Issue" or anything like that.

Please help me.

#41 - 2010-05-05 15:46 - Stanislav German-Evtushenko

This patch doesn't add any new permissions. It's only changes 'what to show' behaviour.

If you have just only 'Add issue' without 'View issue' permission you can see just only own created issues or if you are in watchers.

#42 - 2010-05-05 19:31 - Oleg Volkov

Permission Created issue Assigned issue Watching issue Other issue

Unset "View issue" and

unset "Add issue"

Not view Not view Not view Not view

Unset "View issue" and set

"Add issue"

View View View Not view

Set "View issue" View View View View

#43 - 2010-05-05 21:10 - Oleg Volkov

- File redmine_own_v.2.patch added

In new version:

- Fixed work with attachments

- Minor changes

#44 - 2010-05-06 09:55 - Raghu Sunderam

Hello Everybody

Thank you very much for your support.

I now have figured the way of working of this patch.

#45 - 2010-05-08 20:57 - Thomas Pihl

Can you see the issue if it's assigned to you?

#46 - 2010-05-12 22:14 - Alexander Neundorf

+1

This is a really significant improvement for Redmine, and make it possible to use RedMine in many scenarious where it isn't a suitable solution today,

because external users can either see everything or not even their own issues.
How are the chances that this goes into svn ?

Would be really cool :-)

Alex

#47 - 2010-05-16 19:59 - Andrew M-Y

Applying the patch to v.0.9.4.devel.3739, there were some failures:

patching file lib/redmine.rb

Hunk #1 succeeded at 44 (offset 19 lines).

Hunk #2 FAILED at 57.

Hunk #3 FAILED at 93.

Hunk #4 succeeded at 121 (offset 21 lines).

2 out of 4 hunks FAILED -- saving rejects to file lib/redmine.rb.rej

patching file test/fixtures/issues.yml

Hunk #1 FAILED at 86.

Hunk #2 FAILED at 202.

2 out of 2 hunks FAILED -- saving rejects to file test/fixtures/issues.yml.rej

#48 - 2010-05-17 05:42 - Oleg Volkov

Use stable 0.9.4 version.

#49 - 2010-05-18 21:46 - yannick  quenec'hdu

+1

This function is very important to manage external user

#50 - 2010-05-20 11:09 - Sweet Geng

Hi ! i apply it to Redmine 0.9.2 stable

i find it works well at the begining, it really great.

but i find in "My Page", if user don't have "view issue" permission

he can see nothing in this page

is this problem the same in 0.9.4 or only in .2?

#51 - 2010-05-20 12:01 - Oleg Volkov

So conceived

The following patch allows viewing

--- a/app/models/issue.rb    2010-05-01 16:43:49.000000000 +0400

+++ b/app/models/issue.rb    2010-05-20 13:49:15.595862696 +0400

@@ -54,7 +54,8 @@

   validates_numericality_of :estimated_hours, :allow_nil => true

   named_scope :visible, lambda {|*args| { :include => :project,

-                                          :conditions => Project.allowed_to_condition(args.first || User.curr

ent, :view_issues) } }

+                                          :conditions => Project.allowed_to_condition(args.first || User.curr

ent, :view_issues) +

+                                                ' or ' + Project.allowed_to_condition(args.first || User.curr

ent, :add_issues) } }

   named_scope :open, :conditions => ["#{IssueStatus.table_name}.is_closed = ?", false], :include => :status

#52 - 2010-05-24 09:00 - Sweet Geng

Oleg Volkov wrote:

So conceived

The following patch allows viewing

[...]

 OK got it

works well

thanks very much !

#53 - 2010-05-27 07:31 - Sweet Geng
Oleg Volkov wrote:

So conceived

The following patch allows viewing

[...]

 Hi Oleg Volkov :

going to be perfect , but i find in "My Page" >> "watched issue"

i can also see the issues which already been "closed".

what can i do to not show that closed issues in "My Page"?

thanks very much

#54 - 2010-05-29 12:59 - Oleg Volkov

Sweet Geng wrote:

going to be perfect , but i find in "My Page" >> "watched issue"

i can also see the issues which already been "closed".

what can i do to not show that closed issues in "My Page"?

 This does not apply to #2653

#55 - 2010-05-31 03:07 - Sweet Geng

Oleg Volkov wrote:

Sweet Geng wrote:

going to be perfect , but i find in "My Page" >> "watched issue"

i can also see the issues which already been "closed".

what can i do to not show that closed issues in "My Page"?

 This does not apply to #2653

 Yes, thanks very much

#56 - 2010-06-17 16:50 - Eriks Dobelis

+1

This is a very important one.

Can some target version be set on this?

#57 - 2010-06-19 05:24 - Light Kong

+1

#58 - 2010-07-07 17:28 - Didi Baur

Hi, great patch, exactly what I was looking for. Except, it doesn't appear to work for 0.9.5 stable (just setting "Add Issue" permission, nothing else - I

can't see not even mine). Any chance you could update the patch to work with 0.9.5? Thanks a lot in advance!

#59 - 2010-07-08 11:31 - Anders Aagaard

Great patch, you just saved me a lot of time making it myself :)

#60 - 2010-07-18 10:28 - Wayne Walter

Any way to control this per-project for non-members?

I ask because we have 2 projects that both have ability to receive incoming emails which create new user automatically and create new ticket.

These new users are treated at "non-members" for permissions on projects.

But Redmine only allows setting  Add Issue or View Issue for Non-Members globally, right?

Unless you have another suggestion, my current idea is to add ability to incoming emails to auto-assign the user a chosen role on the project
specified.

So this would be a new parameter for rdm-mailhandler.rb of --role

After doing this it would be possible to make incoming emails from new users automatically get reporter role on one project which has "View Issue"

privilege but they only get Non-Member role on the other project which only has the "Add Issue" privilege.

Maybe this deserves separate ticket on Redmine.

Wayne

#61 - 2010-07-20 08:27 - Oleg Volkov

- File redmine_own_v.2.patch added

#62 - 2010-07-29 14:28 - Joe Goloso

Hello,

I'm running redmine "1.0.0 stable" and have applied the "redmine_own_v.2.patch" as described.

It looks like everything went ok (no errors in the process), but when I disable the "view_issues" permission for the "customer" role, users in this role

are not able to see the "Issues" option in redmine main menu, so obviously, they can not see their "own/assigned/watched" issues, as expected.

Someone else having this problem?

#63 - 2010-07-29 19:40 - Oleg Volkov

Enable "Add_issues" for customer.

#64 - 2010-07-30 13:52 - Joe Goloso

Thanks Oleg for your quick reply!

I've already enabled the "Add_issues" permission in "Roles » (Customer) » Permissions » Issue tracking » Add issues". If this option is not enabled,

customers cannot see the option "New issue" in redmine top menu, so they can't report.

My problem is not Adding issues, but viewing the added issues later when the "View issues" permission is disabled in the "Customer" role.

If I understand how this patch works, I have to disable the "View Issues" permission in my "Customer" role in order for the customers to see only,

Own reported issues (when the customer reports an issue, is able to see it)

Assigned issues (when the customer has an issue assigned, is able to see it)

Watched issues (when the customer is "watcher" for an issue, is able to see it)

This is what I understand from your chart,

Permission Created issue Assigned issue Watching issue Other issue

Unset "View issue" and

unset "Add issue"

Not view Not view Not view Not view

Unset "View issue" and

set "Add issue"

View View View Not view

Set "View issue" View View View View

 But when I unset "View issue" and set "Add issue", users with the "Customer" role can't see any issue.

What can I be doing wrong???

Thanks in advance!

#65 - 2010-07-30 18:57 - Bruno Medeiros

What can I be doing wrong???

 I can't imagine, I've just installed a new instance of Redmine 1.0.0 and applied the patch and everything works ok. My intention here is to use redmine

to manage administrative demands, so the request from one employee can't be showed to other employees. I put on 'Non member' role the following

permissions, separeted by groups:

Post messages
View documents

View files

Add issues

Edit issues

Add notes

View wiki

It's working fine, just as the table above shows. I have other non-non-member role with the same permission and it's working too.

I guess something went wrong with tour installation.

#66 - 2010-08-02 18:04 - Joe Goloso

Ok. I'll install a new instance of redmine 1.0.0 and apply the patch. I'll give you feedback after the test.

Thanks again for your excelent work and support!

#67 - 2010-08-04 16:57 - anisa s.

Hi,

I am also using the latest version of redmine (vs.1.0.0) and I was not able to install the patch. I got the following messages:

File to patch: redmine_own_v.2.patch

patching file redmine_own_v.2.patch

Hunk #1 FAILED at 111.

1 out of 1 hunk FAILED -- saving rejects to file redmine_own_v.2.patch.rej

can't find file to patch at input line 16

Perhaps you used the wrong -p or --strip option?

 Additionally the file redmine_own:v.2patch.rej has the following:

--- redmine-1.0.0/app/controllers/issues_controller.rb  2010-06-05 07:52:59.000000000 +0400

+++ redmine/app/controllers/issues_controller.rb        2010-07-19 19:52:43.152810115 +0400

@@ -111,6 +111,7 @@

   end

   def show

+    return render_403 if !@issue.visible?

     @journals = @issue.journals.find(:all, :include => [:user, :details], :order => "#{Journal.table_name}.cr

eated_on ASC")

     @journals.each_with_index {|j,i| j.indice = i+1}

     @journals.reverse! if User.current.wants_comments_in_reverse_order?

 I would really appreciate your help on this issue.

Thnx in advance!

#68 - 2010-08-04 17:12 - Bruno Medeiros

To apply the patch you need to do the following:

[bruno.medeiros@appserver ~]$ cd /to/your/redmine/current/

[bruno.medeiros@appserver  current]$ ls

app  backup  config  db  doc  extra  files  lib  log  public  Rakefile  README.rdoc  script  test  tmp  vendor

[bruno.medeiros@appserver  current]$ sudo wget http://www.redmine.org/attachments/download/4147/redmine_own_v.

2.patch

[bruno.medeiros@appserver  current]$ sudo patch -p1 < redmine_own_v.2.patch

 I guess you problem is you didn't put the -p correctly, as said on the patch error:

Perhaps you used the wrong -p or --strip option?

#69 - 2010-08-04 18:07 - anisa s.

I actually tried both option "-p" and "--strip" but it did not work.

I followed your instructions and it worked. Before I was using the instructions described on this link http://www.redmine.org/wiki/redmine/patch.

Thnx a lot!
p.s: You also see the issues posted by other members but you cannot read them right?

#70 - 2010-08-04 19:03 - Bruno Medeiros

You don't even see the issues.

I recommend you to do some experiments with fake users and issues to see if this patch does what you really want.

#71 - 2010-08-04 19:14 - Bruno Medeiros

anisa s. wrote:

I actually tried both option "-p" and "--strip" but it did not work.

I followed your instructions and it worked. Before I was using the instructions described on this link http://www.redmine.org/wiki/redmine/patch.

 Yeah, I tried that before too, but Oleg is not creating patches inside Redmine folder as said in this wiki, but one level up. So the -p1 parameters says

to patch to ignore the first folder on the hunks.

#72 - 2010-08-26 04:05 - Bruno Medeiros

I could do a 'svn update' on the 1.0-stable branch and all went fine, no conflicts. I tested the basics and doesn't seems to have permission issues. Has

anyone else tried to update?

#73 - 2010-09-13 18:47 - Eric Davis

- Assignee changed from Jean-Philippe Lang to Eric Davis

Assigning this to myself so I remember to review it once I'm done with a book launch.

#74 - 2010-09-13 18:52 - Oleg Volkov

- File redmine_own_v.2.patch added

#75 - 2010-09-21 02:46 - Steven Hajducko

Tried redmine_own_v.2.patch with a test user on 1.0-stable branch.

Test user has 'Add Issue' permission set, 'View Issue' permission unset.  Test user is able to see issue list, but cannot read any issue details.

#76 - 2010-09-21 03:24 - Steven Hajducko

Steven Hajducko wrote:

Tried redmine_own_v.2.patch with a test user on 1.0-stable branch.

Test user has 'Add Issue' permission set, 'View Issue' permission unset.  Test user is able to see issue list, but cannot read any issue details.

 Figured out the issue.  Test User was actually created with a new role 'Test' that was assigned to the project.  The special 'Non-member' role still had

'View Issues' available.  Once the 'Non-member' role ( which the Test user is NOT a part of ) had it's 'View Issue' permission revoked, the patch

worked.

So the patch requires that the Non-member role not be allowed to view any issues other than issues on those projects a non-member can create

issues on, as a task cannot be assigned to a non-member and in order to watch an issue, a non-member would have to be able see the issue first.

Unfortunately, this makes it rather hard for us, as we use the non-member role for people who would like to comment on issues as well as other trivial

things.  There are specific, targeted people who we would like to restrict their view of the tasks on the project without having to disable the ability of

non-members to view issues.

#77 - 2010-09-21 09:27 - Oleg Volkov

Inheriting privileges from the "no member" is a property redmine, and not the property of the patch 2653.

#78 - 2010-10-07 03:48 - Abhimanyu Grover

Joe Goloso wrote:

Thanks Oleg for your quick reply!

I've already enabled the "Add_issues" permission in "Roles » (Customer) » Permissions » Issue tracking » Add issues". If this option is not

enabled, customers cannot see the option "New issue" in redmine top menu, so they can't report.

My problem is not Adding issues, but viewing the added issues later when the "View issues" permission is disabled in the "Customer" role.
If I understand how this patch works, I have to disable the "View Issues" permission in my "Customer" role in order for the customers to see only,

Own reported issues (when the customer reports an issue, is able to see it)

Assigned issues (when the customer has an issue assigned, is able to see it)

Watched issues (when the customer is "watcher" for an issue, is able to see it)

This is what I understand from your chart,

Permission Created issue Assigned issue Watching issue Other issue

Unset "View issue" and

unset "Add issue"

Not view Not view Not view Not view

Unset "View issue" and

set "Add issue"

View View View Not view

Set "View issue" View View View View

 But when I unset "View issue" and set "Add issue", users with the "Customer" role can't see any issue.

What can I be doing wrong???

Thanks in advance!

 I'm having this exact same issue. Anyone else?

#79 - 2010-10-07 08:37 - Oleg Volkov

Too little information to understand the reason. Are you sure that the patch is installed correctly?

We present a scheme permissions.

#80 - 2010-10-07 21:26 - Diego Felipe

Any plans to include this in the main branch?

Does It work with redmine v. 1.0.2?

I am using the 1.0.1 version, but the new gant features got my attention.

Thanks a lot Oleg.

#81 - 2010-10-07 21:56 - Terence Mill

+1

#82 - 2010-10-08 21:48 - Oleg Volkov

- File redmine_own_v.2.patch added

For redmine 1.0.2

#83 - 2010-10-10 13:56 - Joe Goloso

Abhimanyu Grover wrote:

I'm having this exact same issue. Anyone else?

 Still not solved.

I've confirmed that in a new redmine installation the patch works perfectly, but with my data, it doesn't.

Suggestions are welcome.

Thanks!

#84 - 2010-10-10 14:18 - Oleg Volkov

Joe Goloso wrote:

I've confirmed that in a new redmine installation the patch works perfectly, but with my data, it doesn't.

 Please give your details.
#85 - 2010-10-11 19:47 - Joe Goloso

Oleg Volkov wrote:

Please give your details.

 Hi Oleg,

We have spent the whole morning doing some tests, and finally we have found the problem.

Just reboot redmine after the installations of the patch "redmine_own_v.2.patch - For redmine 1.0.2 (16,4 KB) Oleg Volkov, 2010-10-08 21:48".

Here are the details of my newbie and sad story:

Our first test was to install a new/clean redmine 1.0.2 in a new server and apply the patch. The patch worked perfectly in this procedure. Users with

"customer" role (which had "view issues" permission disabled),

1 - Can see "Issues" option in the redmine main menu.

 2 - Are able to see issues they have assigned/watched.

 3 - Are not able to see issues they don't have assigned/watched.

 In production environment it didn't work. Users with "customer" role (with "view issues" permission disabled), were not able to see the "Issues" option

in the redmine main menu after installing the patch. They couldn't access even their own reported issues.

Then we did a dump of the BBDD of the production server (where the patch didn't work) to the new and clean redmine with the patch working fine,

and everything kept working fine. So, our data (projects, subprojects, roles, users, issues, etc.) is not causing the problem.

Then we thought that the problem could be caused by a plugin, so we cloned all the production environment (redmine files and directories, plugins,

BBDD, etc.) to another server, in order to start a classic "try and error" procedure, uninstalling pluguins one by one. Once we finished uninstalling all

the plugins, realize that the problem persisted.

Then we have tried to restart redmine and the ploblem has been solved. What a shame...

Abhimanyu, you need to install the last patch version "redmine_own_v.2.patch - For redmine 1.0.2 (16,4 KB) Oleg Volkov, 2010-10-08 21:48" if you

are running redmine 1.0.2. This worked for us.

Hope this can help.

Thank you guys for your excellent work. Redmine is the best projects management system. I love it. And now I will be able to share it with the

customers.

#86 - 2010-10-12 06:15 - Oleg Volkov

Joe Goloso wrote:

Then we have tried to restart redmine and the ploblem has been solved.

 This property is Ruby on Rails. Restart needed.

#87 - 2010-10-14 05:16 - Bruno Medeiros

Just to let you all know, trying to do a 'svn update' from 1.0.1 to 1.0.2 does not work, unless you want to manually solve 2 conflicts in lib/redmine.rb (I

did that, but I really didn't want to...).

I think the safest way to update is to 1.0.2 from 1.0.1 is doing a new checkout and applying the rebased patch.

BTW, how can I run the tests? I searched, but i found nothing.. So I tried:

[root@appserver current]# rake test:engines:all

(in /opt/redmine_sup/1.0-stable)

rake aborted!

Access denied for user 'root'@'localhost' (using password: NO)

(See full trace by running task with --trace)

Thanks!

#88 - 2010-10-14 07:33 - Oleg Volkov

I make a patch for the official versions redmine.

Install the new version, then apply the patch.

The patch is being tested by developers, users do not need to run the tests.
#89 - 2010-10-14 10:15 - Terence Mill

Can you make a plugin out of this or when will this be released to core?

#90 - 2010-10-14 11:55 - Oleg Volkov

Terence Mill wrote:

Can you make a plugin out of this

 I will not make a plugin.

or when will this be released to core?

 Eric Devis thinks about it.

#91 - 2010-10-25 16:58 - Eric Davis

- Assignee deleted (Eric Davis)

#92 - 2010-10-25 18:08 - Oleg Volkov

Patch is dead! :(

#93 - 2010-10-27 07:04 - ou liu

Is it possible for not showing view-own-issues only members in Overview/Member area? Also, is it possible not allowing those kind of members

assign their issue? Because you may have an internal way to assign issue to an employee, and it's possible that later that employee just left.

Personally I like redmine a lot, but to use it as a ticketing system which talks to customer directly, there is still a long way to go, especially on security

when there are multiple customers for a project. (for example, can we have files for one customer but not another, wiki entry? document? What if we

want a customer/group to have multiple reporters so that they can see each other's issue but not another customer/group's issue)

#94 - 2010-10-27 07:21 - Oleg Volkov

Use subprojects for different groups

#95 - 2010-11-05 19:57 - Arash Afrooze

Hi oleg,

I tried to apply the patch to redmine 1.0.2 and got a bunch of failures. I'm not very good with redmine and patching in general. After applying the

patch, my user can add issues and the 'View Issues' tab is also there, but they're unable to see the list of their own issues. I've only given them add

issue access.

Here is the result or the patch:

patching file redmine/app/controllers/issues_controller.rb

Hunk #1 succeeded at 99 (offset 2 lines).

patching file redmine/app/models/issue.rb

Hunk #1 succeeded at 92 (offset 18 lines).

patching file redmine/app/models/query.rb

Hunk #1 succeeded at 385 (offset 6 lines).

Hunk #2 FAILED at 407.

Hunk #3 FAILED at 457.

2 out of 3 hunks FAILED -- saving rejects to file redmine/app/models/query.rb.rej

patching file redmine/app/models/user.rb

Hunk #1 FAILED at 339.

Hunk #2 FAILED at 347.

2 out of 2 hunks FAILED -- saving rejects to file redmine/app/models/user.rb.rej

patching file redmine/lib/redmine.rb

Hunk #1 succeeded at 45 (offset 1 line).

Hunk #3 FAILED at 94.

Hunk #4 succeeded at 122 (offset 1 line).

1 out of 4 hunks FAILED -- saving rejects to file redmine/lib/redmine.rb.rej

patching file redmine/test/fixtures/issues.yml

patching file redmine/test/fixtures/member_roles.yml

patching file redmine/test/fixtures/members.yml

patching file redmine/test/fixtures/roles.yml

patching file redmine/test/fixtures/users.yml

Hunk #1 succeeded at 152 with fuzz 2.

patching file redmine/test/fixtures/watchers.yml

patching file redmine/test/functional/issues_controller_test.rb

patching file redmine/test/unit/attachment_test.rb

patching file redmine/test/unit/issue_test.rb
Hunk #2 succeeded at 752 (offset 52 lines).

patching file redmine/test/unit/mailer_test.rb

patching file redmine/vendor/plugins/acts_as_attachable/lib/acts_as_attachable.rb

Thanks a million

#96 - 2010-11-05 20:07 - Oleg Volkov

Arash Afrooze, You are wrong to apply the patch, mistakes should not be.

#97 - 2010-11-05 20:46 - Stanislav German-Evtushenko

I confirm. I just get the last stable version of redmine and applied the patch without any errors.

$ svn co http://redmine.rubyforge.org/svn/branches/1.0-stable redmine-1.0

$ cd redmine-1.0

$ patch -p1 --dry-run -i ../redmine_own_v.2.patch

patching file app/controllers/issues_controller.rb

patching file app/models/issue.rb

patching file app/models/query.rb

patching file app/models/user.rb

patching file lib/redmine.rb

patching file test/fixtures/issues.yml

patching file test/fixtures/member_roles.yml

patching file test/fixtures/members.yml

patching file test/fixtures/roles.yml

patching file test/fixtures/users.yml

patching file test/fixtures/watchers.yml

patching file test/functional/issues_controller_test.rb

patching file test/unit/attachment_test.rb

patching file test/unit/issue_test.rb

Hunk #2 succeeded at 730 (offset 30 lines).

patching file test/unit/mailer_test.rb

patching file vendor/plugins/acts_as_attachable/lib/acts_as_attachable.rb

#98 - 2010-11-10 19:19 - Dov Amihod

Hi,

I am new to Redmine, and was looking for the feature exactly as Oleg has designed it. The problem is that applying the patch has failed for me as

well. I'm using

Redmine 1.0.2.stable (MySQL)

and had errors similar to Arash. My installation is the default one from here

http://www.turnkeylinux.org/redmine

Thanks.

Arash Afrooze wrote:

Hi oleg,

I tried to apply the patch to redmine 1.0.2 and got a bunch of failures. I'm not very good with redmine and patching in general. After applying the

patch, my user can add issues and the 'View Issues' tab is also there, but they're unable to see the list of their own issues. I've only given them

add issue access.

Here is the result or the patch:

patching file redmine/app/controllers/issues_controller.rb

Hunk #1 succeeded at 99 (offset 2 lines).

patching file redmine/app/models/issue.rb

Hunk #1 succeeded at 92 (offset 18 lines).

patching file redmine/app/models/query.rb

Hunk #1 succeeded at 385 (offset 6 lines).

Hunk #2 FAILED at 407.

Hunk #3 FAILED at 457.

2 out of 3 hunks FAILED -- saving rejects to file redmine/app/models/query.rb.rej

patching file redmine/app/models/user.rb

Hunk #1 FAILED at 339.

Hunk #2 FAILED at 347.

2 out of 2 hunks FAILED -- saving rejects to file redmine/app/models/user.rb.rej

patching file redmine/lib/redmine.rb

Hunk #1 succeeded at 45 (offset 1 line).
Hunk #3 FAILED at 94.

Hunk #4 succeeded at 122 (offset 1 line).

1 out of 4 hunks FAILED -- saving rejects to file redmine/lib/redmine.rb.rej

patching file redmine/test/fixtures/issues.yml

patching file redmine/test/fixtures/member_roles.yml

patching file redmine/test/fixtures/members.yml

patching file redmine/test/fixtures/roles.yml

patching file redmine/test/fixtures/users.yml

Hunk #1 succeeded at 152 with fuzz 2.

patching file redmine/test/fixtures/watchers.yml

patching file redmine/test/functional/issues_controller_test.rb

patching file redmine/test/unit/attachment_test.rb

patching file redmine/test/unit/issue_test.rb

Hunk #2 succeeded at 752 (offset 52 lines).

patching file redmine/test/unit/mailer_test.rb

patching file redmine/vendor/plugins/acts_as_attachable/lib/acts_as_attachable.rb

Thanks a million

#99 - 2010-11-10 19:54 - Oleg Volkov

Use last patch for 1.0.2 and 1.0.3 version.

$ wget http://www.redmine.org/attachments/download/4642/redmine_own_v.2.patch

$ wget http://rubyforge.org/frs/download.php/73140/redmine-1.0.3.tar.gz

$ tar -zxvf redmine-1.0.3.tar.gz

$ cd redmine-1.0.3

$ patch -p 1 ../redmine_own_v.2.patch

#100 - 2010-11-10 20:16 - Oleg Volkov

$ patch -p 1 <../redmine_own_v.2.patch

#101 - 2010-11-10 23:39 - Dov Amihod

Hi Oleg,

I've done as you advised ( and took the chance to update to 1.0.3) and it has worked.

Thanks for your help.

Dov

#102 - 2010-11-17 16:25 - Sam Kuper

Eric Davis wrote:

Assigning this to myself so I remember to review it once I'm done with a book launch.

 I read this and thought, "Nice! His book has been launched now, if I'm not mistaken, so hopefully that will mean this patch will make it into core soon."

But then I read this:

Eric Davis wrote:

Assignee deleted (Eric Davis)

 and thought, "Er, that's a bit disappointing. Is this patch going to make it into core or not?"

#103 - 2010-11-17 17:15 - Oleg Volkov

IRC Log:

Q: Feature #2653, Assignee deleted (Eric Davis), why?

E.Davis Answer: I'm limiting the amount of time I'm giving to Redmine now and that feature isn't something I'm interesting in

#104 - 2010-11-17 19:09 - Eric Davis

Sorry if I disappointed you Sam Kuper, things have been getting pretty busy with Redmine and my plugins (I have 250 emails/patches to review for

my plugins alone, not even counting the Redmine core).  With 1.1 coming out soon, I've been focusing on the last features decided on from the 

TeamLeadMeeting3.  And if that wasn't enough, several major things are on hold for me too (backstory).
Only thing I can suggest is to be patient.  All of the contributors I know are aware of this feature request, it's just a problem of limited time right now.

#105 - 2010-11-18 00:32 - Victor Batista

Hi

I have just installed the patch on redmine 1.0.1 with success.

Users without "View issue" and with "Add issue" can see all the issues on the list of issues, but can only see the details of the issues assigned to

them (HTTP 403 for not owned issues).

My doubt is: Should the user view, on the list of issues, issues which are not assigned to him?

Thanks for your time.

Best regards,

Victor Batista

#106 - 2010-11-18 17:27 - Sam Kuper

Oleg Volkov wrote:

IRC Log:

Q: Feature #2653, Assignee deleted (Eric Davis), why?

E.Davis Answer: I'm limiting the amount of time I'm giving to Redmine now and that feature isn't something I'm interesting in

 Eric Davis wrote:

Sorry if I disappointed you Sam Kuper, things have been getting pretty busy with Redmine and my plugins (I have 250 emails/patches to review

for my plugins alone, not even counting the Redmine core).  With 1.1 coming out soon, I've been focusing on the last features decided on from

the TeamLeadMeeting3.  And if that wasn't enough, several major things are on hold for me too (backstory).

Only thing I can suggest is to be patient.  All of the contributors I know are aware of this feature request, it's just a problem of limited time right

now.

 Hi Eric, thanks for clarifying (and Oleg for also helping to clarify Eric's reasons). And fair enough, too; I've sympathy with being overstretched! I've just

not seen devs un-assign tasks to themselves like this before.

Now that I understand what's going on, I agree it's actually quite a good way of saying to the public: "My backlog is so long right now that leaving this

item on it gives the false impression I might actually get it done in a satisfactory timeframe!"

I'm tempted to become a Redmine dev myself so that I can work on some of these issues, but have a fair backlog of my own to clear before I might

be able to manage that. I'd want to read your book first, too :)

#107 - 2010-11-18 21:35 - Eric Davis

Sam Kuper wrote:

Now that I understand what's going on, I agree it's actually quite a good way of saying to the public: "My backlog is so long right now that leaving

this item on it gives the false impression I might actually get it done in a satisfactory timeframe!"

 Exactly. Also lets the other contributors know that I'm not actively working on it so they can pick it up if they want to. (Might be time to take this

conversation off the issue and to the forum, I don't want to clutter up this issue with unneeded content).

#108 - 2010-12-31 12:30 - Anonymous

Hi

is the patch http://www.redmine.org/attachments/download/4642/redmine_own_v.2.patch

compatible with the redmine version 1.0.4 and 1.0.5 ?

Thanks

#109 - 2010-12-31 12:49 - Oleg Volkov

I have not tested.

#110 - 2010-12-31 16:09 - Anoop L

Cheers Oleg Volkov !!!

It's wonderful patch. You have done this without any modification to the UI which makes it so simple.

It's working fine without any issues. I have tested this on Redmine versions 1.0.3, 1.0.4(copy of existing installation) and 1.0.5.

Thank you So much Oleg Volkov.

2025-07-02 16/18

https://www.redmine.org/issues/2653
https://www.redmine.org/projects/redmine/wiki/TeamLeadMeeting3
http://theadmin.org/articles/2010/11/15/things-on-hold/
http://www.redmine.org/attachments/download/4642/redmine_own_v.2.patch


#111 - 2010-12-31 16:31 - Terence Mill

Would be gerat if someone can update this issue with the description for the patch

#112 - 2011-01-26 12:09 - O G

Oleg Volkov wrote:

IRC Log:

Q: Feature #2653, Assignee deleted (Eric Davis), why?

E.Davis Answer: I'm limiting the amount of time I'm giving to Redmine now and that feature isn't something I'm interesting in

 Can Oleg commit this?

Would be great to see this in the next Redmine release!

#113 - 2011-01-27 16:00 - Asmir Mustafic

i need this pathc too!

#114 - 2011-02-04 20:26 - Spenser Jones

- File redmine_own_v.2.patch added

Here is a working patch for the current revision of 1.1-Stable (rev 4797)

#115 - 2011-02-05 01:46 - Stanislav Grebenyukov

Is any chance that this useful function sometime be a part of the trank? In revision 4794 patch doesn't work.

#116 - 2011-02-05 01:56 - Stanislav Grebenyukov

I meen rev. 4787

patch --dry-run -p1 < ./redmine_own_v.2.patch

patching file app/controllers/issues_controller.rb

Hunk #1 succeeded at 103 (offset 6 lines).

patching file app/models/issue.rb

Hunk #1 succeeded at 92 (offset 18 lines).

patching file app/models/query.rb

Hunk #1 succeeded at 389 with fuzz 1 (offset 10 lines).

Hunk #2 succeeded at 411 (offset 10 lines).

Hunk #3 succeeded at 502 (offset 51 lines).

patching file app/models/user.rb

Hunk #1 FAILED at 339.

Hunk #2 succeeded at 386 (offset 39 lines).

1 out of 2 hunks FAILED -- saving rejects to file app/models/user.rb.rej

patching file lib/redmine.rb

Hunk #1 succeeded at 45 (offset 1 line).

Hunk #2 succeeded at 59 (offset 1 line).

Hunk #3 FAILED at 95.

Hunk #4 succeeded at 122 (offset 1 line).

1 out of 4 hunks FAILED -- saving rejects to file lib/redmine.rb.rej

patching file test/fixtures/issues.yml

patching file test/fixtures/member_roles.yml

patching file test/fixtures/members.yml

patching file test/fixtures/roles.yml

Hunk #1 succeeded at 185 (offset 1 line).

patching file test/fixtures/users.yml

Hunk #1 succeeded at 152 with fuzz 2.

patching file test/fixtures/watchers.yml

patching file test/functional/issues_controller_test.rb

Hunk #1 succeeded at 311 (offset 34 lines).

Hunk #2 succeeded at 348 (offset 34 lines).

patching file test/unit/attachment_test.rb

Hunk #1 succeeded at 20 with fuzz 1.

patching file test/unit/issue_test.rb

Hunk #2 succeeded at 771 (offset 71 lines).

patching file test/unit/mailer_test.rb

patching file vendor/plugins/acts_as_attachable/lib/acts_as_attachable.rb

#117 - 2011-02-05 01:57 - Stanislav Grebenyukov

F**k (( rev 4797 :)
#118 - 2011-02-05 02:17 - Bruno Medeiros

Stanislav Grebenyukov wrote:

Is any chance that this useful function sometime be a part of the trank? In revision 4794 patch doesn't work.

 Maybe on Redmine fork, ChiliProject, made by people who want to make a community-driven project:

https://www.chiliproject.org/projects/chiliproject/wiki/Why_Fork

#119 - 2011-02-05 02:52 - Spenser Jones

Stanislav Grebenyukov wrote:

Is any chance that this useful function sometime be a part of the trank? In revision 4794 patch doesn't work.

 If you use the patch I had added a few hours before you, it should run against 4797 just fine. Those two failed hunks were easily corrected.

#120 - 2011-05-30 21:22 - Jean-Philippe Lang

- Status changed from New to Closed

- Resolution set to Duplicate

Superseded by #7412 added in 1.2.0.

Files

redmine_own_v.1.patch 14.8 KB 2010-05-02 Oleg Volkov

redmine_own_v.2.patch 17.4 KB 2010-05-05 Oleg Volkov

redmine_own_v.2.patch 17 KB 2010-07-20 Oleg Volkov

redmine_own_v.2.patch 16.4 KB 2010-09-13 Oleg Volkov

redmine_own_v.2.patch 16.4 KB 2010-10-08 Oleg Volkov

redmine_own_v.2.patch 16.8 KB 2011-02-04 Spenser Jones
